--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -2898,11 +3171,11 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (strcmp(cap, FC_NODE_WWN) == 0) {
 		bcopy((void *)&ha->loginparams.node_ww_name.raw_wwn[0],
@@ -2923,8 +3196,8 @@
 		 * Disable streaming for certain 2 chip adapters
 		 * below Psycho to handle Psycho byte hole issue.
 		 */
-		if ((CFG_IST(ha, CFG_MULTI_CHIP_ADAPTER)) &&
-		    (!CFG_IST(ha, CFG_SBUS_CARD))) {
+		if (ha->flags & MULTI_CHIP_ADAPTER &&
+		    !CFG_IST(ha, CFG_SBUS_CARD)) {
 			for (psydip = ddi_get_parent(ha->dip); psydip;
 			    psydip = ddi_get_parent(psydip)) {
 				if (strcmp(ddi_driver_name(psydip),
@@ -2944,15 +3217,7 @@
 		}
 		rval = FC_CAP_FOUND;
 	} else if (strcmp(cap, FC_CAP_PAYLOAD_SIZE) == 0) {
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
-			*rptr = (uint32_t)CHAR_TO_SHORT(
-			    ha->init_ctrl_blk.cb24.max_frame_length[0],
-			    ha->init_ctrl_blk.cb24.max_frame_length[1]);
-		} else {
-			*rptr = (uint32_t)CHAR_TO_SHORT(
-			    ha->init_ctrl_blk.cb.max_frame_length[0],
-			    ha->init_ctrl_blk.cb.max_frame_length[1]);
-		}
+		*rptr = ha->loginparams.common_service.rx_bufsize;
 		rval = FC_CAP_FOUND;
 	} else if (strcmp(cap, FC_CAP_POST_RESET_BEHAVIOR) == 0) {
 		*rptr = FC_RESET_RETURN_ALL;
@@ -2965,7 +3230,7 @@
 		rval = FC_CAP_ERROR;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -2997,11 +3262,11 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (strcmp(cap, FC_NODE_WWN) == 0) {
 		rval = FC_CAP_FOUND;
@@ -3018,7 +3283,7 @@
 		rval = FC_CAP_ERROR;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -3050,11 +3315,11 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	mapbuf->lilp_magic = (uint16_t)MAGIC_LIRP;
 	mapbuf->lilp_myalpa = ha->d_id.b.al_pa;
@@ -3061,7 +3326,7 @@
 
 	/* Wait for suspension to end. */
 	TASK_DAEMON_LOCK(ha);
-	while (ha->task_daemon_flags & QL_SUSPENDED) {
+	while (DRIVER_SUSPENDED(ha)) {
 		ha->task_daemon_flags |= SUSPENDED_WAKEUP_FLG;
 
 		/* 30 seconds from now */
@@ -3092,18 +3357,18 @@
 		 * chip and restart all over again.
 		 */
 		ql_delay(ha, 2000000);
-		EL(ha, "failed, FC_NOMAP\n");
-		rval = FC_NOMAP;
+		EL(ha, "failed, FC_NO_MAP\n");
+		rval = FC_NO_MAP;
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): my_alpa %xh len %xh "
-		    "data %xh %xh %xh %xh\n", ha->instance,
+		QL_PRINT_3(ha, "my_alpa %xh len %xh "
+		    "data %xh %xh %xh %xh\n",
 		    mapbuf->lilp_myalpa, mapbuf->lilp_length,
 		    mapbuf->lilp_alpalist[0], mapbuf->lilp_alpalist[1],
 		    mapbuf->lilp_alpalist[2], mapbuf->lilp_alpalist[3]);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 #if 0
 	QL_DUMP_3((uint8_t *)mapbuf, 8, sizeof (fc_lilpmap_t));
 #endif
@@ -3138,21 +3403,15 @@
 	/* Verify proper command. */
 	ha = ql_cmd_setup(fca_handle, pkt, &rval);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, ql_cmd_setup=%xh, fcah=%ph\n",
+		QL_PRINT_2(NULL, "failed, ql_cmd_setup=%xh, fcah=%ph\n",
 		    rval, fca_handle);
 		return (rval);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started command:\n", ha->instance);
-#if 0
-	QL_DUMP_3((uint8_t *)&pkt->pkt_cmd_fhdr, 32,
-	    sizeof (fc_frame_hdr_t) / 4);
-	QL_PRINT_3(CE_CONT, "(%d): command:\n", ha->instance);
-	QL_DUMP_3((uint8_t *)pkt->pkt_cmd, 8, pkt->pkt_cmdlen);
-#endif
+	QL_PRINT_3(ha, "started, d_id=%xh\n", pkt->pkt_cmd_fhdr.d_id);
 
 	/* Reset SRB flags. */
 	sp->flags &= ~(SRB_ISP_STARTED | SRB_ISP_COMPLETED | SRB_RETRY |
-	    SRB_POLL | SRB_WATCHDOG_ENABLED | SRB_ABORT | SRB_UB_CALLBACK |
+	    SRB_POLL | SRB_WATCHDOG_ENABLED | SRB_UB_CALLBACK |
 	    SRB_UB_RSCN | SRB_UB_FCP | SRB_FCP_CMD_PKT | SRB_FCP_DATA_PKT |
 	    SRB_FCP_RSP_PKT | SRB_IP_PKT | SRB_GENERIC_SERVICES_PKT |
 	    SRB_COMMAND_TIMEOUT | SRB_ABORTING | SRB_IN_DEVICE_QUEUE |
@@ -3170,6 +3429,10 @@
 		if (pkt->pkt_cmd_fhdr.type == FC_TYPE_SCSI_FCP) {
 			sp->flags |= SRB_FCP_CMD_PKT;
 			rval = ql_fcp_scsi_cmd(ha, pkt, sp);
+		} else {
+			pkt->pkt_state = FC_PKT_LOCAL_RJT;
+			pkt->pkt_reason = FC_REASON_UNSUPPORTED;
+			rval = FC_TRANSPORT_ERROR;
 		}
 		break;
 
@@ -3182,8 +3445,18 @@
 		switch (pkt->pkt_cmd_fhdr.r_ctl) {
 		case R_CTL_UNSOL_DATA:
 			if (pkt->pkt_cmd_fhdr.type == FC_TYPE_IS8802_SNAP) {
-				sp->flags |= SRB_IP_PKT;
-				rval = ql_fcp_ip_cmd(ha, pkt, sp);
+				if (CFG_IST(ha, CFG_FCIP_SUPPORT) &&
+				    ha->vp_index == 0) {
+					sp->flags |= SRB_IP_PKT;
+					rval = ql_fcp_ip_cmd(ha, pkt, sp);
+				} else {
+					cmn_err(CE_NOTE, "%s(%d) FC-IP is not "
+					    "supported on this adapter\n",
+					    QL_NAME, ha->instance);
+					pkt->pkt_state = FC_PKT_LOCAL_RJT;
+					pkt->pkt_reason = FC_REASON_UNSUPPORTED;
+					rval = FC_TRANSPORT_ERROR;
+				}
 			}
 			break;
 
@@ -3191,6 +3464,10 @@
 			if (pkt->pkt_cmd_fhdr.type == FC_TYPE_FC_SERVICES) {
 				sp->flags |= SRB_GENERIC_SERVICES_PKT;
 				rval = ql_fc_services(ha, pkt);
+			} else {
+				pkt->pkt_state = FC_PKT_LOCAL_RJT;
+				pkt->pkt_reason = FC_REASON_UNSUPPORTED;
+				rval = FC_TRANSPORT_ERROR;
 			}
 			break;
 
@@ -3210,7 +3487,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -3255,25 +3532,20 @@
 	/* Check handle. */
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d,%d): started, count = %xh\n",
-	    ha->instance, ha->vp_index, *count);
+	QL_PRINT_3(ha, "started, count = %xh\n", *count);
 
 	QL_PM_LOCK(ha);
 	if (ha->power_level != PM_LEVEL_D0) {
 		QL_PM_UNLOCK(ha);
-		QL_PRINT_3(CE_CONT, "(%d,%d): down done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_3(ha, "down done\n");
 		return (FC_FAILURE);
 	}
 	QL_PM_UNLOCK(ha);
 
-	/* Acquire adapter state lock. */
-	ADAPTER_STATE_LOCK(ha);
-
 	/* Check the count. */
 	if ((*count + ha->ub_allocated) > QL_UB_LIMIT) {
 		*count = 0;
@@ -3389,13 +3661,11 @@
 		}
 	}
 
-	/* Release adapter state lock. */
-	ADAPTER_STATE_UNLOCK(ha);
-
 	/* IP buffer. */
 	if (ub_updated) {
-		if ((type == FC_TYPE_IS8802_SNAP) &&
-		    (!(CFG_IST(ha, (CFG_CTRL_6322 | CFG_CTRL_2581))))) {
+		if (type == FC_TYPE_IS8802_SNAP &&
+		    CFG_IST(ha, CFG_FCIP_SUPPORT) &&
+		    ha->vp_index == 0) {
 
 			ADAPTER_STATE_LOCK(ha);
 			ha->flags |= IP_ENABLED;
@@ -3402,7 +3672,7 @@
 			ADAPTER_STATE_UNLOCK(ha);
 
 			if (!(ha->flags & IP_INITIALIZED)) {
-				if (CFG_IST(ha, CFG_CTRL_2422)) {
+				if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 					ha->ip_init_ctrl_blk.cb24.mtu_size[0] =
 					    LSB(ql_ip_mtu);
 					ha->ip_init_ctrl_blk.cb24.mtu_size[1] =
@@ -3454,8 +3724,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d,%d): done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -3490,15 +3759,12 @@
 	/* Check handle. */
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	/* Acquire adapter state lock. */
-	ADAPTER_STATE_LOCK(ha);
-
 	/* Check all returned tokens. */
 	for (index = 0; index < count; index++) {
 		fc_unsol_buf_t	*ubp;
@@ -3528,9 +3794,7 @@
 		while (!(sp->flags & SRB_UB_IN_FCA) ||
 		    (sp->flags & (SRB_UB_CALLBACK | SRB_UB_ACQUIRED))) {
 			QL_UB_UNLOCK(ha);
-			ADAPTER_STATE_UNLOCK(ha);
 			delay(drv_usectohz(100000));
-			ADAPTER_STATE_LOCK(ha);
 			QL_UB_LOCK(ha);
 		}
 		ha->ub_array[ub_array_index] = NULL;
@@ -3544,18 +3808,17 @@
 		 * no more unsolicited buffers in use.
 		 */
 		if (ha->ub_allocated == 0) {
+			QL_UB_LOCK(ha);
 			cv_broadcast(&ha->pha->cv_ub);
+			QL_UB_UNLOCK(ha);
 		}
 	}
 
-	/* Release adapter state lock. */
-	ADAPTER_STATE_UNLOCK(ha);
-
 	if (rval != FC_SUCCESS) {
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -3592,14 +3855,13 @@
 	/* Check handle. */
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, ": failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, ": failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Acquire adapter state lock. */
-	ADAPTER_STATE_LOCK(ha);
 	QL_UB_LOCK(ha);
 
 	/* Check all returned tokens. */
@@ -3649,8 +3911,6 @@
 	}
 
 	QL_UB_UNLOCK(ha);
-	/* Release adapter state lock. */
-	ADAPTER_STATE_UNLOCK(ha);
 
 	/*
 	 * XXX: We should call ql_isp_rcvbuf() to return a
@@ -3665,7 +3925,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -3692,6 +3952,7 @@
  * Context:
  *	Kernel context.
  */
+/*ARGSUSED*/
 static int
 ql_abort(opaque_t fca_handle, fc_packet_t *pkt, int flags)
 {
@@ -3698,14 +3959,14 @@
 	port_id_t		d_id;
 	ql_link_t		*link;
 	ql_adapter_state_t	*ha, *pha;
-	ql_srb_t		*sp;
 	ql_tgt_t		*tq;
 	ql_lun_t		*lq;
 	int			rval = FC_ABORTED;
+	ql_srb_t		*sp = (ql_srb_t *)pkt->pkt_fca_private;
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
@@ -3712,14 +3973,15 @@
 
 	pha = ha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Get target queue pointer. */
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 	tq = ql_d_id_to_queue(ha, d_id);
 
-	if ((tq == NULL) || (pha->task_daemon_flags & LOOP_DOWN)) {
-		if (tq == NULL) {
+	if ((tq == NULL) || (lq = sp->lun_queue) == NULL ||
+	    (pha->task_daemon_flags & LOOP_DOWN)) {
+		if (tq == NULL || lq == NULL) {
 			EL(ha, "failed, FC_TRANSPORT_ERROR\n");
 			rval = FC_TRANSPORT_ERROR;
 		} else {
@@ -3729,14 +3991,6 @@
 		return (rval);
 	}
 
-	sp = (ql_srb_t *)pkt->pkt_fca_private;
-	lq = sp->lun_queue;
-
-	/* Set poll flag if sleep wanted. */
-	if (flags == KM_SLEEP) {
-		sp->flags |= SRB_POLL;
-	}
-
 	/* Acquire target queue lock. */
 	DEVICE_QUEUE_LOCK(tq);
 	REQUEST_RING_LOCK(ha);
@@ -3783,7 +4037,7 @@
 			pkt->pkt_reason = CS_ABORTED;
 
 			sp->cmd.next = NULL;
-			ql_done(&sp->cmd);
+			ql_done(&sp->cmd, B_TRUE);
 			rval = FC_ABORTED;
 		} else {
 			EL(ha, "failed, FC_BADEXCHANGE\n");
@@ -3809,31 +4063,74 @@
 		DEVICE_QUEUE_UNLOCK(tq);
 		rval = FC_ABORTED;
 	} else {
-		request_t	*ep = pha->request_ring_bp;
-		uint16_t	cnt;
+		ql_request_q_t	*req_q;
+		request_t	*pio;
+		uint32_t	index;
 
+		REQUEST_RING_UNLOCK(ha);
+		DEVICE_QUEUE_UNLOCK(tq);
+
+		INTR_LOCK(ha);
+		sp->flags |= SRB_ABORTING;
 		if (sp->handle != 0) {
-			for (cnt = 0; cnt < REQUEST_ENTRY_CNT; cnt++) {
-				if (sp->handle == ddi_get32(
-				    pha->hba_buf.acc_handle, &ep->handle)) {
-					ep->entry_type = INVALID_ENTRY_TYPE;
-					break;
+			index = sp->handle & OSC_INDEX_MASK;
+			if (ha->outstanding_cmds[index] == sp) {
+				ha->outstanding_cmds[index] =
+				    QL_ABORTED_SRB(ha);
+			}
+			if (ha->req_q[1] != NULL && sp->rsp_q_number != 0) {
+				req_q = ha->req_q[1];
+			} else {
+				req_q = ha->req_q[0];
+			}
+			pio = sp->request_ring_ptr;
+			if (sp->handle ==
+			    ddi_get32(req_q->req_ring.acc_handle,
+			    &pio->handle)) {
+				EL(ha, "inflight sp=%ph, handle=%xh, "
+				    "invalidated\n", (void *)sp, sp->handle);
+				for (index = 0; index < sp->req_cnt; index++) {
+					ddi_put8(req_q->req_ring.acc_handle,
+					    &pio->entry_type,
+					    ABORTED_ENTRY_TYPE);
+					pio++;
+					if (pio == (request_t *)
+					    ((uintptr_t)req_q->req_ring.bp +
+					    req_q->req_ring.size)) {
+						pio = req_q->req_ring.bp;
+					}
 				}
-				ep++;
 			}
+			/* Decrement outstanding commands on device. */
+			if (tq->outcnt != 0) {
+				tq->outcnt--;
+			}
+			if (sp->flags & SRB_FCP_CMD_PKT &&
+			    lq->lun_outcnt != 0) {
+				lq->lun_outcnt--;
+			}
+			/* Remove command from watchdog queue. */
+			if (sp->flags & SRB_WATCHDOG_ENABLED) {
+				ql_remove_link(&tq->wdg, &sp->wdg);
+				sp->flags &= ~SRB_WATCHDOG_ENABLED;
+			}
+			/* Release device queue lock. */
+			INTR_UNLOCK(ha);
+
+			(void) ql_abort_command(ha, sp);
+			sp->handle = 0;
+		} else {
+			/* Release device queue lock. */
+			INTR_UNLOCK(ha);
 		}
 
-		/* Release device queue lock. */
-		REQUEST_RING_UNLOCK(ha);
-		DEVICE_QUEUE_UNLOCK(tq);
-
-		sp->flags |= SRB_ABORTING;
-		(void) ql_abort_command(ha, sp);
+		sp->flags &= ~SRB_IN_TOKEN_ARRAY;
+		sp->flags |= SRB_ISP_COMPLETED;
 		pkt->pkt_reason = CS_ABORTED;
 		rval = FC_ABORTED;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d,%d): done\n", ha->instance, ha->vp_index);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -3862,14 +4159,20 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d,%d): started, cmd=%d\n", ha->instance,
-	    ha->vp_index, cmd);
+	QL_PRINT_3(ha, "started, cmd=%d\n", cmd);
 
+	if (ha->task_daemon_flags & (ABORT_ISP_ACTIVE | LOOP_RESYNC_ACTIVE |
+	    DRIVER_STALL | ISP_ABORT_NEEDED | LOOP_RESYNC_NEEDED)) {
+		EL(ha, "driver stalled, FC_TRAN_BUSY, dtf=%xh\n",
+		    ha->task_daemon_flags);
+		return (FC_TRAN_BUSY);
+	}
+
 	switch (cmd) {
 	case FC_FCA_CORE:
 		/* dump firmware core if specified. */
@@ -3960,8 +4263,7 @@
 		EL(ha, "cmd=%xh, failed=%xh\n", cmd, rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d,%d): done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -4005,29 +4307,26 @@
 	int			rval2, rval = FC_SUCCESS;
 	uint32_t		opcode;
 	uint32_t		set_flags = 0;
+	fc_fca_p2p_info_t	*p2p_info;
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, ": failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, ": failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
 	pha = ha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started=%xh\n", ha->instance,
-	    cmd->pm_cmd_code);
+#ifdef	QL_DEBUG_LEVEL_10
+	if (cmd->pm_cmd_code != FC_PORT_GET_FW_REV) {
+		QL_PRINT_10(ha, "started=%xh\n", cmd->pm_cmd_code);
+	}
+#endif
 
-	ql_awaken_task_daemon(ha, NULL, DRIVER_STALL, 0);
-
-	/*
-	 * Wait for all outstanding commands to complete
-	 */
-	index = (uint16_t)ql_wait_outstanding(ha);
-
-	if (index != MAX_OUTSTANDING_COMMANDS) {
-		ql_awaken_task_daemon(ha, NULL, 0, DRIVER_STALL);
-		ql_restart_queues(ha);
-		EL(ha, "failed, FC_TRAN_BUSY\n");
+	if (ha->task_daemon_flags & (ABORT_ISP_ACTIVE | LOOP_RESYNC_ACTIVE |
+	    DRIVER_STALL | ISP_ABORT_NEEDED | LOOP_RESYNC_NEEDED)) {
+		EL(ha, "driver stalled, FC_TRAN_BUSY, dtf=%xh\n",
+		    ha->task_daemon_flags);
 		return (FC_TRAN_BUSY);
 	}
 
@@ -4117,66 +4416,17 @@
 		QL_DUMP_UNLOCK(pha);
 		break;
 	case FC_PORT_FORCE_DUMP:
-		PORTMANAGE_LOCK(ha);
 		if (ql_dump_firmware(ha) != QL_SUCCESS) {
 			EL(ha, "failed, FC_PORT_FORCE_DUMP FC_FAILURE\n");
 			rval = FC_FAILURE;
 		}
-		PORTMANAGE_UNLOCK(ha);
 		break;
-	case FC_PORT_DOWNLOAD_FW:
-		PORTMANAGE_LOCK(ha);
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
-			if (ql_24xx_load_flash(ha, (uint8_t *)cmd->pm_data_buf,
-			    (uint32_t)cmd->pm_data_len,
-			    ha->flash_fw_addr << 2) != QL_SUCCESS) {
-				EL(ha, "failed, FC_PORT_DOWNLOAD_FW\n");
-				rval = FC_FAILURE;
-			}
-			ql_reset_chip(ha);
-			set_flags |= ISP_ABORT_NEEDED;
-		} else {
-			/* Save copy of the firmware. */
-			if (pha->risc_code != NULL) {
-				kmem_free(pha->risc_code, pha->risc_code_size);
-				pha->risc_code = NULL;
-				pha->risc_code_size = 0;
-			}
-
-			pha->risc_code = kmem_alloc(cmd->pm_data_len,
-			    KM_SLEEP);
-			if (pha->risc_code != NULL) {
-				pha->risc_code_size =
-				    (uint32_t)cmd->pm_data_len;
-				bcopy(cmd->pm_data_buf, pha->risc_code,
-				    cmd->pm_data_len);
-
-				/* Do abort to force reload. */
-				ql_reset_chip(ha);
-				if (ql_abort_isp(ha) != QL_SUCCESS) {
-					kmem_free(pha->risc_code,
-					    pha->risc_code_size);
-					pha->risc_code = NULL;
-					pha->risc_code_size = 0;
-					ql_reset_chip(ha);
-					(void) ql_abort_isp(ha);
-					EL(ha, "failed, FC_PORT_DOWNLOAD_FW"
-					    " FC_FAILURE\n");
-					rval = FC_FAILURE;
-				}
-			}
-		}
-		PORTMANAGE_UNLOCK(ha);
-		break;
 	case FC_PORT_GET_DUMP_SIZE:
 		bp = (uint32_t *)cmd->pm_data_buf;
 		*bp = pha->risc_dump_size;
 		break;
 	case FC_PORT_DIAG:
-		/*
-		 * Prevents concurrent diags
-		 */
-		PORTMANAGE_LOCK(ha);
+		EL(ha, "diag cmd=%xh\n", cmd->pm_cmd_flags);
 
 		/* Wait for suspension to end. */
 		for (timer = 0; timer < 3000 &&
@@ -4187,10 +4437,17 @@
 		if (pha->task_daemon_flags & QL_LOOP_TRANSITION) {
 			EL(ha, "failed, FC_TRAN_BUSY-2\n");
 			rval = FC_TRAN_BUSY;
-			PORTMANAGE_UNLOCK(ha);
 			break;
 		}
 
+		if ((rval2 = ql_stall_driver(ha, 0)) != QL_SUCCESS) {
+			EL(ha, "stall_driver status=%xh, FC_TRAN_BUSY\n",
+			    rval2);
+			ql_restart_driver(ha);
+			rval = FC_TRAN_BUSY;
+			break;
+		}
+
 		switch (cmd->pm_cmd_flags) {
 		case QL_DIAG_EXEFMW:
 			if (ql_start_firmware(ha) != QL_SUCCESS) {
@@ -4199,7 +4456,7 @@
 			}
 			break;
 		case QL_DIAG_CHKCMDQUE:
-			for (i0 = 1, cnt = 0; i0 < MAX_OUTSTANDING_COMMANDS;
+			for (i0 = 1, cnt = 0; i0 < pha->osc_max_cnt;
 			    i0++) {
 				cnt += (pha->outstanding_cmds[i0] != NULL);
 			}
@@ -4254,7 +4511,7 @@
 			 * Don't do the wrap test on a 2200 when the
 			 * firmware is running.
 			 */
-			if (!CFG_IST(ha, CFG_CTRL_2200)) {
+			if (!CFG_IST(ha, CFG_CTRL_22XX)) {
 				mcp = (app_mbx_cmd_t *)cmd->pm_data_buf;
 				mr.mb[1] = mcp->mb[1];
 				mr.mb[2] = mcp->mb[2];
@@ -4332,7 +4589,7 @@
 			    cmd->pm_data_len, DDI_DEV_AUTOINCR);
 
 			/* 22xx's adapter must be in loop mode for test. */
-			if (CFG_IST(ha, CFG_CTRL_2200)) {
+			if (CFG_IST(ha, CFG_CTRL_22XX)) {
 				bptr = &ha->init_ctrl_blk.cb.add_fw_opt[0];
 				if (ha->flags & POINT_TO_POINT ||
 				    (ha->task_daemon_flags & LOOP_DOWN &&
@@ -4360,6 +4617,10 @@
 			lb->receive_data_address =
 			    buffer_rcv.cookie.dmac_address;
 
+			if (CFG_IST(ha, CFG_LOOP_POINT_SUPPORT)) {
+				(void) ql_set_loop_point(ha, lb->options);
+			}
+
 			if (ql_loop_back(ha, 0, lb,
 			    buffer_xmt.cookie.dmac_notused,
 			    buffer_rcv.cookie.dmac_notused) == QL_SUCCESS) {
@@ -4375,6 +4636,10 @@
 				rval = FC_FAILURE;
 			}
 
+			if (CFG_IST(ha, CFG_LOOP_POINT_SUPPORT)) {
+				(void) ql_set_loop_point(ha, 0);
+			}
+
 			ql_free_phys(ha, &buffer_xmt);
 			ql_free_phys(ha, &buffer_rcv);
 
@@ -4444,7 +4709,7 @@
 			 */
 			echo.options = BIT_15;
 			if (CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING) &&
-			    !(CFG_IST(ha, CFG_CTRL_8081))) {
+			    !(CFG_IST(ha, CFG_FCOE_SUPPORT))) {
 				echo.options = (uint16_t)
 				    (echo.options | BIT_6);
 			}
@@ -4533,7 +4798,7 @@
 			rval = FC_INVALID_REQUEST;
 			break;
 		}
-		PORTMANAGE_UNLOCK(ha);
+		ql_restart_driver(ha);
 		break;
 	case FC_PORT_LINK_STATE:
 		/* Check for name equal to null. */
@@ -4578,6 +4843,13 @@
 		}
 		break;
 	case FC_PORT_INITIALIZE:
+		if ((rval2 = ql_stall_driver(ha, 0)) != QL_SUCCESS) {
+			EL(ha, "stall_driver status=%xh, FC_TRAN_BUSY\n",
+			    rval2);
+			ql_restart_driver(ha);
+			rval = FC_TRAN_BUSY;
+			break;
+		}
 		if (cmd->pm_cmd_len >= 8) {
 			tq = NULL;
 			for (index = 0; index < DEVICE_HEAD_LIST_SIZE &&
@@ -4611,6 +4883,7 @@
 
 			rval = FC_FAILURE;
 		}
+		ql_restart_driver(ha);
 		break;
 	case FC_PORT_RLS:
 		if (cmd->pm_data_len < sizeof (fc_rls_acc_t)) {
@@ -4633,6 +4906,8 @@
 			LITTLE_ENDIAN_32(&rls->rls_link_fail);
 			LITTLE_ENDIAN_32(&rls->rls_sync_loss);
 			LITTLE_ENDIAN_32(&rls->rls_sig_loss);
+			LITTLE_ENDIAN_32(&rls->rls_prim_seq_err);
+			LITTLE_ENDIAN_32(&rls->rls_invalid_word);
 			LITTLE_ENDIAN_32(&rls->rls_invalid_crc);
 #endif /* _BIG_ENDIAN */
 		}
@@ -4652,8 +4927,14 @@
 		}
 		break;
 	case FC_PORT_DOWNLOAD_FCODE:
-		PORTMANAGE_LOCK(ha);
-		if ((CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+		if ((rval2 = ql_stall_driver(ha, 0)) != QL_SUCCESS) {
+			EL(ha, "stall_driver status=%xh, FC_TRAN_BUSY\n",
+			    rval2);
+			ql_restart_driver(ha);
+			rval = FC_TRAN_BUSY;
+			break;
+		}
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 			rval = ql_load_flash(ha, (uint8_t *)cmd->pm_data_buf,
 			    (uint32_t)cmd->pm_data_len);
 		} else {
@@ -4681,8 +4962,55 @@
 		}
 		ql_reset_chip(ha);
 		set_flags |= ISP_ABORT_NEEDED;
-		PORTMANAGE_UNLOCK(ha);
+		ql_restart_driver(ha);
 		break;
+
+	case FC_PORT_GET_P2P_INFO:
+
+		bzero(cmd->pm_data_buf, cmd->pm_data_len);
+		if (cmd->pm_data_len < sizeof (fc_fca_p2p_info_t)) {
+			EL(ha, "inadequate data length")
+			rval = FC_NOMEM;
+			break;
+		}
+
+		p2p_info = (fc_fca_p2p_info_t *)cmd->pm_data_buf;
+
+		if ((ha->topology & QL_N_PORT) &&
+		    (ha->flags & POINT_TO_POINT)) {
+			p2p_info->fca_d_id = ha->d_id.b24;
+			p2p_info->d_id = ha->n_port->d_id.b24;
+
+			bcopy((void *) &ha->n_port->port_name[0],
+			    (caddr_t)&p2p_info->pwwn, 8);
+			bcopy((void *) &ha->n_port->node_name[0],
+			    (caddr_t)&p2p_info->nwwn, 8);
+			rval = FC_SUCCESS;
+
+			EL(ha, "P2P HID=%xh, d_id=%xh, WWPN=%02x%02x%02x%02x"
+			    "%02x%02x%02x%02x : "
+			    "WWNN=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+			    p2p_info->fca_d_id, p2p_info->d_id,
+			    ha->n_port->port_name[0],
+			    ha->n_port->port_name[1], ha->n_port->port_name[2],
+			    ha->n_port->port_name[3], ha->n_port->port_name[4],
+			    ha->n_port->port_name[5], ha->n_port->port_name[6],
+			    ha->n_port->port_name[7], ha->n_port->node_name[0],
+			    ha->n_port->node_name[1], ha->n_port->node_name[2],
+			    ha->n_port->node_name[3], ha->n_port->node_name[4],
+			    ha->n_port->node_name[5], ha->n_port->node_name[6],
+			    ha->n_port->node_name[7]);
+			break;
+		} else {
+			EL(ha, "No p2p info reported in non n2n topology\n");
+			rval = FC_BADCMD;
+		}
+		break;
+
+	case FC_PORT_DOWNLOAD_FW:
+		EL(ha, "unsupported=%xh, FC_BADCMD\n", cmd->pm_cmd_code);
+		rval = FC_BADCMD;
+		break;
 	default:
 		EL(ha, "unknown=%xh, FC_BADCMD\n", cmd->pm_cmd_code);
 		rval = FC_BADCMD;
@@ -4698,13 +5026,11 @@
 		ql_delay(ha, 10000);
 	}
 
-	ql_restart_queues(ha);
-
 	if (rval != FC_SUCCESS) {
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -4722,19 +5048,19 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (NULL);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance, id.b24);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", id.b24);
 
 	tq = ql_d_id_to_queue(ha, id);
 
-	if (tq == NULL) {
-		EL(ha, "failed, tq=NULL\n");
+	if (tq == NULL && id.b24 != 0 && id.b24 != FS_BROADCAST) {
+		EL(ha, "failed, no tq available for d_id: %xh\n", id.b24);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (tq);
 }
@@ -4773,13 +5099,13 @@
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
 		*rval = FC_UNBOUND;
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (NULL);
 	}
 	pha = ha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ddi_in_panic() || pkt->pkt_tran_flags & FC_TRAN_DUMPING) {
 		return (ha);
@@ -4829,6 +5155,26 @@
 		}
 	}
 
+	/* Check for packet already running. */
+	if (sp->handle != 0) {
+		*rval = FC_DEVICE_BUSY;
+		cmn_err(CE_WARN, "%s(%d) already running pkt=%p, sp=%p, "
+		    "sp->pkt=%p, sp->hdl=%x, spf=%x, cq=%p\n", QL_NAME,
+		    ha->instance, (void *)pkt, (void *)sp, (void *)sp->pkt,
+		    sp->handle, sp->flags, (void *)sp->cmd.head);
+		return (NULL);
+	}
+	if (ha->rsp_queues_cnt > 1) {
+		ADAPTER_STATE_LOCK(ha);
+		sp->rsp_q_number = ha->rsp_q_number++;
+		if (ha->rsp_q_number == ha->rsp_queues_cnt) {
+			ha->rsp_q_number = 0;
+		}
+		ADAPTER_STATE_UNLOCK(ha);
+	} else {
+		sp->rsp_q_number = 0;
+	}
+
 	/*
 	 * Check DMA pointers.
 	 */
@@ -4835,9 +5181,11 @@
 	*rval = DDI_SUCCESS;
 	if (pkt->pkt_cmd_acc != NULL && pkt->pkt_cmdlen) {
 		QL_CLEAR_DMA_HANDLE(pkt->pkt_cmd_dma);
-		*rval = ddi_check_dma_handle(pkt->pkt_cmd_dma);
-		if (*rval == DDI_SUCCESS) {
-			*rval = ddi_check_acc_handle(pkt->pkt_cmd_acc);
+
+		*rval = qlc_fm_check_dma_handle(ha, pkt->pkt_cmd_dma);
+		if (*rval == DDI_FM_OK) {
+			*rval = qlc_fm_check_acc_handle(ha,
+			    pkt->pkt_cmd_acc);
 		}
 	}
 
@@ -4844,9 +5192,11 @@
 	if (pkt->pkt_resp_acc != NULL && *rval == DDI_SUCCESS &&
 	    pkt->pkt_rsplen != 0) {
 		QL_CLEAR_DMA_HANDLE(pkt->pkt_resp_dma);
-		*rval = ddi_check_dma_handle(pkt->pkt_resp_dma);
-		if (*rval == DDI_SUCCESS) {
-			*rval = ddi_check_acc_handle(pkt->pkt_resp_acc);
+
+		*rval = qlc_fm_check_dma_handle(ha, pkt->pkt_resp_dma);
+		if (*rval == DDI_FM_OK) {
+			*rval = qlc_fm_check_acc_handle(ha,
+			    pkt->pkt_resp_acc);
 		}
 	}
 
@@ -4856,19 +5206,23 @@
 	if (((pkt->pkt_data_acc != NULL) & (*rval == DDI_SUCCESS) &
 	    (pkt->pkt_datalen != 0)) != 0) {
 		QL_CLEAR_DMA_HANDLE(pkt->pkt_data_dma);
-		*rval = ddi_check_dma_handle(pkt->pkt_data_dma);
-		if (*rval == DDI_SUCCESS) {
-			*rval = ddi_check_acc_handle(pkt->pkt_data_acc);
+
+		*rval = qlc_fm_check_dma_handle(ha, pkt->pkt_data_dma);
+		if (*rval == DDI_FM_OK) {
+			*rval = qlc_fm_check_acc_handle(ha,
+			    pkt->pkt_data_acc);
 		}
 	}
 
-	if (*rval != DDI_SUCCESS) {
+	if (*rval != DDI_FM_OK) {
 		pkt->pkt_state = FC_PKT_TRAN_ERROR;
 		pkt->pkt_reason = FC_REASON_DMA_ERROR;
+		pkt->pkt_expln = FC_EXPLN_NONE;
+		pkt->pkt_action = FC_ACTION_RETRYABLE;
 
 		/* Do command callback. */
 		if (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp) {
-			ql_awaken_task_daemon(ha, sp, 0, 0);
+			ql_io_comp(sp);
 		}
 		*rval = FC_BADPACKET;
 		EL(ha, "failed, bad DMA pointers\n");
@@ -4882,7 +5236,7 @@
 	}
 	*rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (ha);
 }
@@ -4912,13 +5266,12 @@
 	int			ret;
 	int			rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    pkt->pkt_cmd_fhdr.d_id);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", pkt->pkt_cmd_fhdr.d_id);
 
 	TASK_DAEMON_LOCK(ha);
 	if (!(ha->task_daemon_flags & STATE_ONLINE)) {
 		TASK_DAEMON_UNLOCK(ha);
-		QL_PRINT_3(CE_CONT, "(%d): offline done\n", ha->instance);
+		QL_PRINT_3(ha, "offline done\n");
 		return (FC_OFFLINE);
 	}
 	TASK_DAEMON_UNLOCK(ha);
@@ -4928,7 +5281,7 @@
 
 	ret = QL_SUCCESS;
 
-	if (CFG_IST(ha, CFG_CTRL_2425) && ha->topology & QL_N_PORT) {
+	if (CFG_IST(ha, CFG_N2N_SUPPORT) && ha->topology & QL_N_PORT) {
 		/*
 		 * In p2p topology it sends a PLOGI after determining
 		 * it has the N_Port login initiative.
@@ -4974,7 +5327,8 @@
 		acc.ls_code.ls_code = LA_ELS_ACC;
 		acc.common_service.fcph_version = 0x2006;
 		acc.common_service.cmn_features = 0x8800;
-		acc.common_service.rx_bufsize = QL_MAX_FRAME_SIZE(ha);
+		acc.common_service.rx_bufsize =
+		    ha->loginparams.common_service.rx_bufsize;
 		acc.common_service.conc_sequences = 0xff;
 		acc.common_service.relative_offset = 0x03;
 		acc.common_service.e_d_tov = 0x7d0;
@@ -5002,12 +5356,12 @@
 			DEVICE_QUEUE_LOCK(tq);
 			tq->logout_sent = 0;
 			tq->flags &= ~TQF_NEED_AUTHENTICATION;
-			if (CFG_IST(ha, CFG_CTRL_242581)) {
+			if (CFG_IST(ha, CFG_IIDMA_SUPPORT)) {
 				tq->flags |= TQF_IIDMA_NEEDED;
 			}
 			DEVICE_QUEUE_UNLOCK(tq);
 
-			if (CFG_IST(ha, CFG_CTRL_242581)) {
+			if (CFG_IST(ha, CFG_IIDMA_SUPPORT)) {
 				TASK_DAEMON_LOCK(ha);
 				ha->task_daemon_flags |= TD_IIDMA_NEEDED;
 				TASK_DAEMON_UNLOCK(ha);
@@ -5066,7 +5420,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -5095,6 +5449,7 @@
 	int		rval;
 	port_id_t	d_id;
 	ql_srb_t	*sp = (ql_srb_t *)pkt->pkt_fca_private;
+	uint16_t	loop_id;
 
 	tq->d_id.b.al_pa = 0;
 	tq->d_id.b.area = 0;
@@ -5108,12 +5463,12 @@
 	for (id = 0; id <= LAST_LOCAL_LOOP_ID; id++) {
 		tq->loop_id = id;
 		rval = ql_get_port_database(ha, tq, PDF_NONE);
-		EL(ha, "rval=%xh\n", rval);
+		EL(ha, "rval=%xh, id=%x\n", rval, id);
 		/* check all the ones not logged in for possible use */
 		if (rval == QL_NOT_LOGGED_IN) {
 			if (tq->master_state == PD_STATE_PLOGI_PENDING) {
 				ha->n_port->n_port_handle = tq->loop_id;
-				EL(ha, "n_port_handle =%xh, master state=%x\n",
+				EL(ha, "loop_id=%xh, master state=%x\n",
 				    tq->loop_id, tq->master_state);
 				break;
 			}
@@ -5124,13 +5479,13 @@
 			if (tq->master_state == PD_STATE_PORT_UNAVAILABLE) {
 				/* if the port_id matches, reuse it */
 				if (pkt->pkt_cmd_fhdr.d_id == tq->d_id.b24) {
-					EL(ha, "n_port_handle =%xh,"
+					EL(ha, "n_port_handle loop_id=%xh, "
 					    "master state=%xh\n",
 					    tq->loop_id, tq->master_state);
 					break;
 				} else if (tq->loop_id ==
 				    ha->n_port->n_port_handle) {
-				    // avoid a lint error
+				    /* avoid a lint error */
 					uint16_t *hndl;
 					uint16_t val;
 
@@ -5140,7 +5495,7 @@
 					val++;
 					*hndl = val;
 				}
-			EL(ha, "rval=%xh, id=%d, n_port_handle =%xh, "
+			EL(ha, "rval=%xh, id=%d, n_port_handle loop_id=%xh, "
 			    "master state=%x\n", rval, id, tq->loop_id,
 			    tq->master_state);
 			}
@@ -5153,7 +5508,7 @@
 				    tq->loop_id, tq->master_state);
 				break;
 			}
-			EL(ha, "rval=%xh, id=%d, n_port_handle =%xh, "
+			EL(ha, "rval=%xh, id=%d, n_port_handle loop_id=%xh, "
 			    "master state=%x\n", rval, id, tq->loop_id,
 			    tq->master_state);
 		}
